<center>
<form id="folder" name="folder" method="post" action="<?php echo Horde::applicationUrl('xppublish.php', true) ?>">
<input type="hidden" name="cmd" value="select" />
<?php Util::pformInput() ?>
<table border="0" cellpadding="1" cellspacing="1">
<tr>
  <td align="center" class="header"><?php echo _("Browse to the folder to upload files to") ?></td>
</tr>
<tr>
  <td class="control"><?php echo _("When you are inside the folder you wish to upload to, click the 'Next' button to upload files.") ?></td>
</tr>
<tr>
  <td class="item">
<?php

// List the folders in the current directory.
$list = Gollem::listFolder(Gollem::getDir());
if (is_a($list, 'PEAR_Error')) {
    // If this is a user's home directory, try autocreating it.
    if (Gollem::getDir() == Gollem::getHome()) {
        Gollem::createFolder('', Gollem::getHome());
        $list = Gollem::listFolder(Gollem::getDir());
    }

    // If that didn't work, fall back to the parent or the home
    // directory.
    if (is_a($list, 'PEAR_Error')) {
        $notification->push(sprintf(_("Permission denied to %s: %s"), Gollem::getDir(), $list->getMessage()), 'horde.error');

        $loc = strrpos(Gollem::getDir(), '/');
        if ($loc !== false) {
            Gollem::setDir(substr(Gollem::getDir(), 0, $loc));
        } else {
            Gollem::setDir(Gollem::getHome());
        }
        $list = Gollem::listFolder(Gollem::getDir());
    }
}

if (is_array($list) && count($list)) {
    /* Read the columns to display from the preferences. */
    $sources = Gollem::string2Columns($prefs->getValue('columns'));
    $columns = isset($sources[$backend_key]) ?
        $sources[$backend_key] : $backends[$backend_key]['attributes'];

    require GOLLEM_TEMPLATES . '/manager/file_headers.inc';
    foreach ($list as $key => $item) {
        $name = str_replace(' ', '&nbsp;', htmlspecialchars($item['name']));
        if ($item['type'] == '**dir') {
            $url = Horde::applicationUrl('manager.php');
            $url = Util::addParameter($url, 'dir', Gollem::subdirectory(Gollem::getDir(), $item['name']));
            $link = Horde::link($url, $item['name']) . '<b>' . $name . '</b></a>';
        } elseif ($item['type'] == '**sym' &&
                  $item['linktype'] === '**dir') {
            if (substr($item['link'], 0, 1) == '/') {
                $parts = explode('/', $item['link']);
                $name = array_pop($parts);
                $dir = implode('/', $parts);
            } else {
                $name = $item['link'];
                $dir = Gollem::getDir();
            }

            $url = Horde::applicationUrl('manager.php');
            $url = Util::addParameter($url, 'dir', Gollem::subdirectory($dir, $name));
            $link = htmlspecialchars($item['name']) . ' -> <b>' . Horde::link($url, $item['link']) . $item['link'] . '</a></b>';
        } else {
            continue;
        }
        require GOLLEM_TEMPLATES . '/manager/file_summaries.inc';
    }
    require GOLLEM_TEMPLATES . '/manager/file_footers.inc';
} else {
    echo _("There are no folders in the current folder; click 'Next' if you want to upload files to this folder.");
}
?>
  </td>
</tr>
</table>
</form>
</center>
